<?php
namespace Teknisa\PLA\Controllers;

use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class ImagemAlergenico extends \Teknisa\GER\Controllers\TeknisaCrud {
	
	protected $servicoService;
	protected $crudService;
	protected $dataSourceManager;
	protected $util;
	protected $dtprocessa;
	protected $dataSourceName = 'imagemalergenico';
	protected $dataSourceNameToSave = false;
	protected $parameterBagColumns = array();
	protected $novoCodigo;
	protected $connection;
	protected $imgPathURL;

	public function __construct($crudService, $parameterBag , $dataSourceManager, $util, $novoCodigo, $connection, $imgPathURL) {
		parent::__construct($crudService, $parameterBag);
		$this->crudService = $crudService;
		$this->dataSourceManager = $dataSourceManager;
		$this->util = $util;
		$this->novoCodigo = $novoCodigo;
		$this->connection = $connection;
		$this->imgPathURL = $imgPathURL;
	}
	
	public function campoImagemGrid(DTO\Request $request, DTO\Response $response) {
		$conditions = [];
		$imagemAlergenico = $this->crudService->getFilteredDataSet("imagemalergenico", $conditions)->getRows();


		foreach ($imagemAlergenico as &$row) {
			if ($row["DSIMAGEM"] !== null) {
				$row["DSIMAGEM"] = $this->imgPathURL.$row["DSIMAGEM"];
			}
		}

		$response->addDataSet(new DataSet ('campoImagemGrid', array($imagemAlergenico)));
		
	}
	
	public function saveImgAlergenico(DTO\Request $request, DTO\Response $response) {
		$row = $request->getRow();
		if (isset($row["IMAGE_UPLOAD"]) && isset($row["IMAGE_UPLOAD"]["0"]) 
		&& isset($row["IMAGE_UPLOAD"]["0"]["path"]) && $row["IMAGE_UPLOAD"]["0"]["path"] !== null) {
			$row["DSIMAGEM"] = $row["IMAGE_UPLOAD"]["0"]["path"];
		} else if(isset($row["FGFOTOFILE"]) && $row["FGFOTOFILE"] !== null) {
			$row["DSIMAGEM"] = $row["FGFOTOFILE"];
		}

	    $response->addDataSet(new DataSet ('imagemalergenico', array($row)));
	    
	}
	
	private function handleException( $message ){
		preg_match("/fkpla01306imagemalergenico/", $message, $matchesPostgre);
        preg_match("/ORA-[0-9]{5}/", $message, $matchesOracle);
        
        if(!empty($matchesOracle)){
            list($exceptionCode) = $matchesOracle; 
            
            switch( $exceptionCode ) {
                case "ORA-02292": return "ERR_MSG_IMG_RECORD_ALER";
                default: return $message;
            }
        } 
        
        if(!empty($matchesPostgre)) {
        	list($exceptionCode) = $matchesPostgre;
        	
        	switch( $exceptionCode ) {
				case "fkpla01306imagemalergenico": 
					return "ERR_MSG_IMG_RECORD_ALER";
	            default: return $message;
        	}
        } 
        
        return $message;
    }
	
	public function removeImgAlergenico(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $dataSet = new DataSet($this->dataSourceName, array($request->getRow()));
    	    $newRequest = new DTO\Request\DataSet($dataSet, '', '', '');
    	    $rowsToDelete = $this->crudService->getRowsToDelete($newRequest, $this->dataSourceName);
    	    $dataSet = new DataSet($this->dataSourceName, (array)$rowsToDelete);
    	    $this->crudService->delete($response, $dataSet);
        } catch(\Exception $e) {
        	$message = $this->handleException($e->getMessage());
            $response->setError(new Error($message, $e->getCode()));       
        }
    }
	
}