<?php

namespace Teknisa\PLA\Modules\Cardapio\Services;

use Zeedhi\Framework\DataSource\FilterCriteria;
use \Setforms2\Shared\ORM\DateTime;
use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DTO;

class Pla10130AtualizaCardapioComBaseNoCicloService {
    
    protected $entityManager;
    protected $environment;
    
    public function __construct($environment, $entityManager) {
        $this->environment = $environment;
        $this->entityManager = $entityManager;
    }

    public function getnrlogcardciclo($cdfilial) {
        $query = "
                    SELECT NVL(MAX(NRLOGCARDCICLO), 0) AS NRLOGCARDCICLO
                      FROM LOGCARDCICLO
                     WHERE CDFILIAL = :CDFILIAL
                ";
        $params  = array(
            "CDFILIAL" => $cdfilial
        );
        
        $sql = $this->entityManager->getConnection()->prepare($query);
        $sql->execute($params);
        $resultado = $sql->fetch();
        if($resultado != false){
            return $resultado['NRLOGCARDCICLO']; 
        }
        return '0000000000';
    }
    
    public function criaCardCiclo($row, $cdfilial, $cdservfili) {
        $connection = $this->entityManager->getConnection();
        $procedure = new StoredProcedure($connection, 'CRIACARD_CICLO');
        $procedure->addParam(new Param('P_CDFILIAL',        Param::PARAM_INPUT, $cdfilial,                    Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDSERVFILI',      Param::PARAM_INPUT, $cdservfili,                   Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTMESCARD',       Param::PARAM_INPUT, $row['DTMESCARDAPIO'],                  Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDOPERADOR',      Param::PARAM_INPUT, $this->environment->getCdOperador(),    Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_IDEXCLUIRCARD',   Param::PARAM_INPUT, 'S',                                    Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRLOGCARDCICLO',  Param::PARAM_INPUT, $row['NRLOG'],                          Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDPADCICLO',      Param::PARAM_INPUT, $row['CDPADCICLO'],                     Param::PARAM_TYPE_STR));
        $procedure->execute();
    }
    
}